<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyfobVoiceDescriptor ArrayType
 * @subpackage Arrays
 */
class ArrayOfKeyfobVoiceDescriptor extends AbstractStructArrayBase
{
    /**
     * The KeyfobVoiceDescriptor
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\KeyfobVoiceDescriptor[]
     */
    public $KeyfobVoiceDescriptor;
    /**
     * Constructor method for ArrayOfKeyfobVoiceDescriptor
     * @uses ArrayOfKeyfobVoiceDescriptor::setKeyfobVoiceDescriptor()
     * @param \CustomerManagement\StructType\KeyfobVoiceDescriptor[] $keyfobVoiceDescriptor
     */
    public function __construct(array $keyfobVoiceDescriptor = array())
    {
        $this
            ->setKeyfobVoiceDescriptor($keyfobVoiceDescriptor);
    }
    /**
     * Get KeyfobVoiceDescriptor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor[]|null
     */
    public function getKeyfobVoiceDescriptor()
    {
        return isset($this->KeyfobVoiceDescriptor) ? $this->KeyfobVoiceDescriptor : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyfobVoiceDescriptor method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyfobVoiceDescriptor method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyfobVoiceDescriptorForArrayConstraintsFromSetKeyfobVoiceDescriptor(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem instanceof \CustomerManagement\StructType\KeyfobVoiceDescriptor) {
                $invalidValues[] = is_object($arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem) ? get_class($arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem) : sprintf('%s(%s)', gettype($arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem), var_export($arrayOfKeyfobVoiceDescriptorKeyfobVoiceDescriptorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyfobVoiceDescriptor property can only contain items of type \CustomerManagement\StructType\KeyfobVoiceDescriptor, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyfobVoiceDescriptor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobVoiceDescriptor[] $keyfobVoiceDescriptor
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobVoiceDescriptor
     */
    public function setKeyfobVoiceDescriptor(array $keyfobVoiceDescriptor = array())
    {
        // validation for constraint: array
        if ('' !== ($keyfobVoiceDescriptorArrayErrorMessage = self::validateKeyfobVoiceDescriptorForArrayConstraintsFromSetKeyfobVoiceDescriptor($keyfobVoiceDescriptor))) {
            throw new \InvalidArgumentException($keyfobVoiceDescriptorArrayErrorMessage, __LINE__);
        }
        if (is_null($keyfobVoiceDescriptor) || (is_array($keyfobVoiceDescriptor) && empty($keyfobVoiceDescriptor))) {
            unset($this->KeyfobVoiceDescriptor);
        } else {
            $this->KeyfobVoiceDescriptor = $keyfobVoiceDescriptor;
        }
        return $this;
    }
    /**
     * Add item to KeyfobVoiceDescriptor value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobVoiceDescriptor $item
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobVoiceDescriptor
     */
    public function addToKeyfobVoiceDescriptor(\CustomerManagement\StructType\KeyfobVoiceDescriptor $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\KeyfobVoiceDescriptor) {
            throw new \InvalidArgumentException(sprintf('The KeyfobVoiceDescriptor property can only contain items of type \CustomerManagement\StructType\KeyfobVoiceDescriptor, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyfobVoiceDescriptor[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\KeyfobVoiceDescriptor|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyfobVoiceDescriptor
     */
    public function getAttributeName()
    {
        return 'KeyfobVoiceDescriptor';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobVoiceDescriptor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
